# UI expression and action script functions

logger = system.util.getLogger(system.util.getProjectName() + '.' + system.reflect.getModulePath())

tkCtx = system.util.toolkitCtx()

@system.util.runInGateway
def getChartOptions():
	options = []
	if tkCtx.getModule("com.kyvislabs.apexcharts"):
		options.append(dict(value='Apex', label="Apex"))
	options.append(dict(value='TS', label="IA TS"))
	return options
#

# Construct the nested items property for a tag folder to be used
# in a Perspective TreeView component.  Recurse into further nested
# folders and UDT instances.
def itemizeFolder(subject, selectionParts=None):
	item = dict(subject)
	item['expanded'] = bool(selectionParts) and selectionParts[0] == item['label']
	innerSelection = selectionParts[1:] if item['expanded'] else []
	foldersMap = item.pop('folders', {})
	udtsMap = item.pop('udts', {})
	item['items'] = [itemizeFolder(x, innerSelection) for x in foldersMap.values() if x.get('name', '') != '_types_'] + [itemizeFolder(x, innerSelection) for x in udtsMap.values()]
	return item
#
# Construct the nested items property for a tag provider to be used
# in a Perspective TreeView component.  Recurse into folders and
# UDT instances.
def itemizeProvider(subject, selectionParts=None):
	foldersMap = subject.get('folders', {})
	udtsMap = subject.get('udts', {})
	items = [itemizeFolder(x, selectionParts) for x in foldersMap.values() if x.get('name', '') != '_types_'] + [itemizeFolder(x, selectionParts) for x in udtsMap.values()]
	selIndices = []
	data = None
	srchItems = items
	while True:
		for i, item in enumerate(srchItems):
			if item['expanded']:
				selIndices.append(i)
				srchItems = item['items']
				data = item['data']
				break
		else:
			break
	return items, '/'.join(str(x) for x in selIndices), data
#

